package connections

import (
	account "gitlab.mashroom.com/mashroom/backend/account/api"
	address "gitlab.mashroom.com/mashroom/backend/address/api"
	auth "gitlab.mashroom.com/mashroom/backend/auth/api"
	cardpayment "gitlab.mashroom.com/mashroom/backend/cardpayment/api"
	"gitlab.mashroom.com/mashroom/backend/common/generic/env"
	"gitlab.mashroom.com/mashroom/backend/common/generic/grpc"
	contract "gitlab.mashroom.com/mashroom/backend/contract/api"
	document "gitlab.mashroom.com/mashroom/backend/document/api"
	extras "gitlab.mashroom.com/mashroom/backend/extras/api"
	geo "gitlab.mashroom.com/mashroom/backend/geo/api"
	grabdata "gitlab.mashroom.com/mashroom/backend/grabdata/api"
	insurance "gitlab.mashroom.com/mashroom/backend/insurance/api"
	invitation "gitlab.mashroom.com/mashroom/backend/invitation/api"
	invoice "gitlab.mashroom.com/mashroom/backend/invoice/api"
	maintenance "gitlab.mashroom.com/mashroom/backend/maintenance/api"
	messaging "gitlab.mashroom.com/mashroom/backend/messaging/api"
	mixpanel "gitlab.mashroom.com/mashroom/backend/mixpanel/api"
	mortgage "gitlab.mashroom.com/mashroom/backend/mortgage/api"
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	oauth "gitlab.mashroom.com/mashroom/backend/oauth/api"
	offer "gitlab.mashroom.com/mashroom/backend/offer/api"
	property "gitlab.mashroom.com/mashroom/backend/property/api"
	rightmove "gitlab.mashroom.com/mashroom/backend/rightmove/api"
	signature "gitlab.mashroom.com/mashroom/backend/signature/api"
	stats "gitlab.mashroom.com/mashroom/backend/stats/api"
	tokenio "gitlab.mashroom.com/mashroom/backend/tokenio/api"
	twilio "gitlab.mashroom.com/mashroom/backend/twilio/api"
	zoopla "gitlab.mashroom.com/mashroom/backend/zoopla/api"
)

var SiteURL = env.ResolveString("SITE_URL", "dev.env.mashroom.com")

var AccountServiceURL = env.ResolveString("ACCOUNT_SERVICE_URL", "mashroom-account:10000")
var AccountService = account.NewAccountServiceClient(grpc.Dial(AccountServiceURL, "Account"))

var AuthServiceURL = env.ResolveString("AUTH_SERVICE_URL", "mashroom-auth:10000")
var AuthService = auth.NewAuthServiceClient(grpc.Dial(AuthServiceURL, "Auth"))

var ContractServiceURL = env.ResolveString("CONTRACT_SERVICE_URL", "mashroom-contract:10000")
var ContractService = contract.NewContractServiceClient(grpc.Dial(ContractServiceURL, "Contract"))

var InvitationServiceURL = env.ResolveString("INVITATION_SERVICE_URL", "mashroom-invitation:10000")
var InvitationService = invitation.NewInvitationServiceClient(grpc.Dial(InvitationServiceURL, "Invitation"))

var MessagingServiceURL = env.ResolveString("MESSAGING_SERVICE_URL", "mashroom-messaging:10000")
var MessagingService = messaging.NewMessagingServiceClient(grpc.Dial(MessagingServiceURL, "Messaging"))

var OfferServiceURL = env.ResolveString("OFFER_SERVICE_URL", "mashroom-offer:10000")
var OfferService = offer.NewOfferServiceClient(grpc.Dial(OfferServiceURL, "Offer"))

var PropertyServiceURL = env.ResolveString("PROPERTY_SERVICE_URL", "mashroom-property:10000")
var PropertyService = property.NewPropertyServiceClient(grpc.Dial(PropertyServiceURL, "Property"))

var AddressServiceURL = env.ResolveString("ADDRESS_SERVICE_URL", "mashroom-address:10000")
var AddressService = address.NewAddressServiceClient(grpc.Dial(AddressServiceURL, "Address"))

var GeoServiceURL = env.ResolveString("GEO_SERVICE_URL", "mashroom-geo:10000")
var GeoService = geo.NewGeoServiceClient(grpc.Dial(GeoServiceURL, "Geo"))

var SignatureServiceURL = env.ResolveString("SIGNATURE_SERVICE_URL", "mashroom-signature:10000")
var SignatureService = signature.NewSignatureServiceClient(grpc.Dial(SignatureServiceURL, "Signature"))

var OauthServiceURL = env.ResolveString("OAUTH_SERVICE_URL", "mashroom-oauth:10000")
var OauthService = oauth.NewOAuthServiceClient(grpc.Dial(OauthServiceURL, "Oauth"))

var DocumentServiceURL = env.ResolveString("DOCUMENT_SERVICE_URL", "mashroom-document:10000")
var DocumentService = document.NewDocumentServiceClient(grpc.Dial(DocumentServiceURL, "Document"))

var ExtrasServiceURL = env.ResolveString("EXTRAS_SERVICE_URL", "mashroom-extras:10000")
var ExtrasService = extras.NewExtrasServiceClient(grpc.Dial(ExtrasServiceURL, "Extras"))

var CardPaymentServiceURL = env.ResolveString("CARDPAYMENT_SERVICE_URL", "mashroom-cardpayment:10000")
var CardPaymentService = cardpayment.NewCardpaymentServiceClient(grpc.Dial(CardPaymentServiceURL, "Cardpayment"))

var InvoiceServiceURL = env.ResolveString("INVOICE_SERVICE_URL", "mashroom-invoice:10000")
var InvoiceService = invoice.NewInvoiceServiceClient(grpc.Dial(InvoiceServiceURL, "Invoice"))

var RightmoveServiceURL = env.ResolveString("RIGHTMOVE_SERVICE_URL", "mashroom-rightmove:10000")
var RightmoveService = rightmove.NewRightmoveServiceClient(grpc.Dial(RightmoveServiceURL, "Rightmove"))

var ZooplaServiceURL = env.ResolveString("ZOOPLA_SERVICE_URL", "mashroom-zoopla:10000")
var ZooplaService = zoopla.NewZooplaServiceClient(grpc.Dial(ZooplaServiceURL, "Zoopla"))

var MaintenanceServiceURL = env.ResolveString("MAINTENANCE_SERVICE_URL", "mashroom-maintenance:10000")
var MaintenanceService = maintenance.NewMaintenanceServiceClient(grpc.Dial(MaintenanceServiceURL, "Maintenance"))

var TwilioServiceURL = env.ResolveString("TWILIO_SERVICE_URL", "mashroom-twilio:10000")
var TwilioService = twilio.NewTwilioServiceClient(grpc.Dial(TwilioServiceURL, "Twilio"))

var NotificationServiceURL = env.ResolveString("NOTIFICATION_SERVICE_URL", "mashroom-notification:10000")
var NotificationService = notification.NewNotificationServiceClient(grpc.Dial(NotificationServiceURL, "Notification"))

var TokenioServiceURL = env.ResolveString("TOKENIO_SERVICE_URL", "mashroom-tokenio:10000")
var TokenioService = tokenio.NewTokenioServiceClient(grpc.Dial(TokenioServiceURL, "Tokenio"))

var StatsServiceURL = env.ResolveString("STATS_SERVICE_URL", "mashroom-stats:10000")
var StatsService = stats.NewStatsServiceClient(grpc.Dial(StatsServiceURL, "Stats"))

var MortgageServiceURL = env.ResolveString("MORTGAGE_SERVICE_URL", "mashroom-mortgage:10000")
var MortgageService = mortgage.NewMortgageServiceClient(grpc.Dial(MortgageServiceURL, "Mortgage"))

var InsuranceServiceURL = env.ResolveString("INSURANCE_SERVICE_URL", "mashroom-insurance:10000")
var InsuranceService = insurance.NewInsuranceServiceClient(grpc.Dial(InsuranceServiceURL, "Insurance"))

var MixpanelService = mixpanel.NewMixpanelServiceClient(grpc.Dial(
	env.ResolveString("MIXPANEL_SERVICE_URL", "mashroom-mixpanel:10000"),
	"Mixpanel",
))

var GrabDataServiceURL = env.ResolveString("GRABDATA_SERVICE_URL", "mashroom-grabdata:10000")
var GrabDataService = grabdata.NewGrabDataServiceClient(grpc.Dial(GrabDataServiceURL, "Grabdata"))
